<template lang="pug">
  div.row
    div.col-lg-4.card(v-for="(candidate, x) in candidates" :key="x")
      div.card-block
        h4.card-title {{ candidate.name }}
        div.card-text {{ candidate.score }}
        button.btn.btn-primary(@click="addVote(candidate)" type="button") Vote
</template>

<script>
export default {
  name: 'voting',
  data () {
    return {
      startNumber: 0,
      endNumber: 3,
      candidates: [
        {name: 'Maulana', score: 0, id: '1'},
        {name: 'Mohammad', score: 0, id: '2'},
        {name: 'Luthfy', score: 0, id: '3'}
      ]
    }
  },
  methods: {
    addVote (candidate) {
      this.candidates.forEach(c => {
        if (c.id === candidate.id) {
          c.score += 1
        }
      })
      this.doBroadcast(candidate)
    },
    doBroadcast (candidate) {
      const option = {
        timeout: 2000,
        showProgressBar: false
      }
      this.$snotify.success(`${candidate.name} has been voted`, option)
    },
    getRandom (start, end) {
      return Math.floor(Math.random() * end) + start
    },
    doSimulation () {
      setInterval(() => {
        const rand = this.getRandom(this.startNumber, this.endNumber)
        this.addVote(this.candidates[rand])
        console.log(rand)
      }, 3000)
    }
  },
  mounted () {
    this.doSimulation()
  }
}
</script>

<style scoped>
.candidate {
  cursor: pointer;
}
</style>
